<script setup lang="ts">
    import {computed} from "vue";

    const props = defineProps(["dataset", "fields", "labels"])

    function getPercentile(data, percentile) {
        const index = (percentile/100) * data.length;
        let result;

        if (Math.floor(index) == index) {
            result = (parseFloat(data[index-1]) + parseFloat(data[index])) / 2;
        } else {
            result = parseFloat(data[Math.floor(index)]);
        }

        return result;
    }

    const getSeries = computed(() => {
        const data : any[] = [];

        for(let fieldIndex in props.fields) {
            const filterData = props.dataset.map(element => element[props.fields[fieldIndex]]).sort((a, b) => a - b);

            const q1 = getPercentile(filterData, 25);
            const median = getPercentile(filterData, 50);
            const q3 = getPercentile(filterData, 75);

            const dataPoint = {
                x: props.labels[fieldIndex],
                y: [
                    parseFloat(filterData[0]),
                    q1,
                    median,
                    q3,
                    parseFloat(filterData[filterData.length - 1])
                ]
            }

            data.push(dataPoint);
        }

        return [{
            type: "boxPlot",
            data: data
        }];
    })

    function getBoxplotChartOptions() {
        return {
            chart: {
                type: 'boxPlot',
                height: "100%",
                width: "100%",
                toolbar: {
                    show: false
                },
                zoom: {
                    enabled: false
                }
            },
            yaxis: {
                decimalsInFloat: 0
            },
            dataLabels: {
                formatter: function (val, {seriesIndex, w}) {
                    return w.config.series[seriesIndex];
                }
            }
        };
    }

</script>
<template>
    <apexchart height="100%" :series="getSeries" :options="getBoxplotChartOptions()"></apexchart>
</template>